
	DS 8

	DW Init	       ;#00
	DW CloseAll     ;#01

	DW PrintAHL     ;#02   (AHL)
	DW PrintA       ;#03   "A"
	DW Refresh      ;#04    
	dw GetWin	;#05 뤠  IX,LY ⥫ 

;--------------------------------------------------------
	db 0
String  db "console v0.2",0
;Coded by Stels	19.08.2000

;	
Len	EQU 20
Hgt	EQU 14

STACK	EQU #5FFF
Ker	EQU #5B00
OPg	EQU 4
OAd	EQU #C000
Temp	EQU #6000
NameLen	EQU #5D06 ;  
Name	EQU #5CDD ;Name	[16b]
ZadN	EQU Temp+3;  
PageN	EQU Temp+8; 
CallFn	EQU Ker+6
CallDos	EQU Ker+9
CallPg	EQU Ker+12
Return	EQU Ker+15
Ret	EQU Ker+18
ReturnF	EQU Ker+21;  
Halt	EQU #5B2A

;-----------------------------------------
MaxLen	EQU 34	;  
Buffer	DS MaxLen
	DB #FF,#FF ; 

;뤠  YL,IX ⥫ 
GetWin	ld a,(PageN)
	ld yl,a
	ld ix,MenuW
	ret

Table
		db "winman  "
		db 0
		db 3 ;  ꥪ  ⥪
MinimBtn	ds 3
		db #ff
		DB "command "
CommandN	db 0
                db #FF
                db "console "
ConsoleN        db 0
                db #FF
                db "WindowL0"
WindowLN        db 0
                db #FF

                db 0

;	ASCIIZ (AHL)
PrintAHL LD C,A
PrAHL_	CALL CallFn
	DB 23   ;LD A,(CHL)
	OR A
	RET Z	; 
	PUSH HL
	PUSH BC
	CALL PrintA
	POP BC
	POP HL
	INC HL
	JR PrAHL_

;  ""
PrintA	CP #0D
	JR Z,NextString
	PUSH IX
	PUSH IY
	LD IX,MenuS
	LD B,A
	LD A,(PageN)
	LD YL,A
	LD A,B
	CALL CallFn
	DB 27   ;PrintA   	

	POP IY
	POP IX
	RET
; 
NextString
	CALL WinUp
     ;		
	PUSH IX
	PUSH IY
	LD IX,MenuS
	LD A,(PageN)
	LD YL,A
	LD A,10
	LD B,8
	CALL CallFn
	DB 58 ;LD (LY,IX+A),B
	POP IY
	POP IX
	RET

;   
Init
    	ld a,(PageN):ld hl,Table
        call CallFn:db 47

    ; 
	CALL ClearBuffer
	CALL Kursor
	LD (Buffer),A	;   
;	CALL PrintBuffer

	LD A,(PageN)
	LD IX,MenuW
	CALL CallFn
	 DB 15	       ;OpenWin
        RET

CloseAll
     ;	 
	LD A,(PageN)
	LD HL,MenuW
	CALL CallFn
	DB 76   ;CloseWAHL

; 
Close
    	ld a,(PageN):ld hl,Table
        call CallFn:db 92
        ld a,(ConsoleN)
        call CallFn:db 69
	ret

CloseLib call CloseAll
	jp Return

ConsoleB
	ld a,b
        cp 5
	jr z,CB1
	 xor a:ret
CB1
     ;ந諮 ⨥  
        call CallFn:db 8	;A=Inkey
        jp LInit

LInit   push af
	LD IX,MenuS
	LD A,(PageN)
	LD YL,A
        pop af

	CP #07
	JR Z,LRus	;Rus/Lat
	CP #08
	JR Z,New	;<--
	CP #0C
	JR Z,LDel	;Delete
	CP #0D
	JR Z,Enter	;Enter
	CP 6
	JR Z,CL		;Caps/Lock
	CP #20
	jp c,ReturnF

	CALL PushSymbol	;  
	CALL PrintBuffer
	jp ReturnF

; 
Enter
	CALL LastAdr
	LD (HL),0	; 	  
	CALL PrintBuffer
	CALL WinUp
    ; 		COMMAND.LIB
	PUSH IX
	PUSH IY
	LD A,(ConsoleN)
	LD YH,A
	LD A,(CommandN); 
	LD B,A
	LD YL,A
	LD C,2	; 
	LD A,(PageN)
	LD HL,Buffer
	CALL CallFn
	DB 43   ;LibFun
	POP IY
	POP IX

    ; 
New
	CALL ClearBuffer
	CALL Kursor
	LD (Buffer),A	;   
	CALL PrintBuffer

	jp Return

; 	 Caps/Lock
CL	CALL CallFn	;InMode
	 DB 9
	XOR 1
	JR LR_
; 	 /
LRus
	CALL CallFn	;InMode
	 DB 9
	XOR 2
LR_	CALL CallFn	;OutMode
	 DB 10
	CALL LastAdr
	CALL Kursor
	LD (HL),A	;	
	CALL PrintBuffer
	jp ReturnF

;  
LDel	CALL DelSymbol
	CALL PrintBuffer
	JP ReturnF

;  
WinUp	PUSH IX
	PUSH IY
	LD A,(PageN)
	LD YL,A
	LD IX,MenuW
    ;  
	LD HL,#0101
	LD D,Hgt-2
	LD E,Len-2
	LD A,(WindowLN)
	LD B,A
	LD C,9	;UpWin
	CALL CallFn
	DB 43   ;LibFun
    ;  
	LD A,(WindowLN)
	LD B,A
	LD C,6	;ClearWin
	LD H,Hgt-2 ;Y
	LD L,1
	LD D,1
	LD E,Len-2
	CALL CallFn
	DB 43
    ;     
	LD A,21+10
	LD B,8	;X  
	CALL CallFn
	DB 58 ;LD (LY,IX+A),B

	POP IY
	POP IX
	CALL Refresh	; 
	RET

;   
DelSymbol
	CALL LastAdr
	PUSH HL
	LD DE,Buffer
	OR A
	SBC HL,DE ; 		
	POP HL
	RET Z	;      
	LD (HL),0
	DEC HL
	CALL Kursor
	LD (HL),A
	RET

;    "A"
PushSymbol
	PUSH AF
	CALL LastAdr
	INC HL
	LD A,(HL)
	INC A
	JR Z,PushS0	;   
	CALL Kursor
	LD (HL),A	;	
	DEC HL
	POP AF
	LD (HL),A	; 
	RET
PushS0	POP AF
	RET

;	 HL    	
LastAdr	LD HL,Buffer
LastAdrN LD A,(HL)
	OR A
	JR Z,LastAdrE
	INC A
	JR Z,LastAdrE
	INC HL
	JR LastAdrN
LastAdrE DEC HL
	RET

;  
PrintBuffer
	LD C,8
	LD B,Hgt-2
	CALL CallFn
	 DB 41  ;AT_BC   
    ;	  ASCIIZ
	CALL LastAdr
	INC HL
	LD A,(HL)
	LD (HL),0
	PUSH HL
	PUSH AF
    ; ASCIIZ
	LD A,(PageN)
	LD HL,Buffer
	CALL CallFn
	DB 19   ;PrintAHL
    ; 
	POP AF
	POP HL
	LD (HL),A

	LD A," "
	CALL CallFn
	DB 27   ;PrintA
    ;⮡ࠧ ⮫쪮 ।᫥ ப ࠭
	push IX,IY
	ld a,(PageN)
	ld yl,a
	ld ix,MenuW
	ld c,1
	ld e,Len-2
	ld b,Hgt-2
	ld d,1	
	CALL CallFn
	DB 82   
	pop IY,IX
	ret
	
;   
;(塞 ⮫쪮 業ࠫ  )
Refresh	PUSH IX
	PUSH IY
	ld a,(PageN)
	ld yl,a
	ld ix,MenuW
	ld bc,#0101
	ld d,Hgt-2
	ld e,Len-2	
	CALL CallFn
	DB 82   
	POP IY
	POP IX
	RET

;	 ""     
; 
Kursor	PUSH HL
	CALL CallFn	;	 
	 DB 9
	BIT 0,A
	JR NZ,KCaps
  ;  
	BIT 1,A
	LD A,#C2     ;Rus
	JR NZ,$+4
	LD A,#CB     ;Lat
	POP HL
	RET
  ;  
KCaps	BIT 1,A
	LD A,""     ;Rus
	JR NZ,$+4
	LD A,""     ;Lat
	POP HL
	RET


;  
ClearBuffer
	LD HL,Buffer
	LD DE,Buffer+1
	LD BC,MaxLen
	LD (HL),0
	LDIR
	RET

;..
MenuW	DB 5,3		       ;0  X,Y 
	DB Len,Hgt	       ;2  Len,Hgt
	DB 0		       ;4  	 .
	DB #FF		       ;5 	.
	 DW MenuS
	DB #FF		       ;8  .
	 DW MenuO
	DB #FF		       ;11 	
	 DW MenuP
	DB #FF		       ;14 ..
	 DW MenuT
	DB #FF		       ;Hot key
	 DW MenuK
	DB 1		       ;20  
;  [16]
MenuS
	DB Len,Hgt;2  Len,Hgt
	DW 0    ;2  ..(.)
	DB #41  ;4  	
	DW Len*Hgt*8  ;5	   
	DB Len*Hgt*9/256+1;7     
	DB 0    ;8   
	DB #38  ;9  .
	DB 0,0  ;10 ..  X,Y
	DB 1    ;12 .OA
	DB 0    ;13 ...
	DW 0    ;14 

MenuO
      ; "CloseWindow"
       DB 11
	 DB OPg
	  DW OAd+21     ;Button
	db Len-1,0,1,1
	 DB #FF
	  DW CloseLib

		db 7 	;   ꥪ, ⠭
		db #ff	; ࠭ ꥪ. #ff 㪠뢠  ⥪.
		dw MinimBtn-#c000 ; ⭮⥫쭠 뫪  ꥪ  ࠭.
				  ; ஡  뫪  NewObj.txt

		db #FF
                dw String
	DB 4
	DB #FF
	DW ConsoleB

       DB 0

; : Atribute,X,Y,Len,Hgt
MenuP	DB #78,Len-1,0,1,1	; "CloseWindow"
	DB #78,Len-2,0,1,1	; 樨
       DB 0

;  :
MenuT
	DB 8,#41,9,0,10,"Console V0.2",13
	DB 8,#01,9,8
	DB 0
	DB 3,Len-1,0,#11	       ; "CloseWindow"
        db 3,Len-2,0,15
	DB 0

;  .
;+0  - 
;X,Y - .
MenuK
	DB "c"	       ;CloseWindow
	DB Len-1,0
        db "m"
        db Len-2,0
       DB 0

END

